//
// Copyright 2000, Kirk Davis (kbd@ndx.net)
//
// Use and distribute freely. Share your changes for others.
// Use at your own risk - no warrantee expressed or implied
// (but you knew that).
//

union RReg
    {
    unsigned short Word;
    struct
       {
       unsigned char LowByte;
       unsigned char HighByte;
       };
    };

struct Regs {
	union RReg R[16];		// Main Regs
	unsigned char D;		// Accumulator
	unsigned char DF;		// ALU Carry
	unsigned char B;		// Aux holding reg
	unsigned char P;		// which reg is PC
	unsigned char X;		// which reg is data
	unsigned char N;		// Low order nibble of instruction
	unsigned char I;		// high order nibble of instuction
	unsigned char T;		// old X & P after interrupt
	unsigned char IE;		// irq ena
	unsigned char Q;		// Q bit
	unsigned char EF1;
	unsigned char EF2;
	unsigned char EF3;
	unsigned char EF4;
};


#define R(Y)	Regs.R[Y].Word
#define RL(Y)	Regs.R[Y].LowByte
#define RH(Y)	Regs.R[Y].HighByte
#define X		Regs.X
#define PC		R(P)
#define M(Y)	Mem[Y]
#define D		Regs.D
#define N		Regs.N
#define P		Regs.P
#define Q		Regs.Q
#define B		Regs.B
#define DF		Regs.DF
#define I		Regs.I
#define IE		Regs.IE
#define T		Regs.T
#define EF1		Regs.EF1
#define EF2		Regs.EF2
#define EF3		Regs.EF3
#define EF4		Regs.EF4

extern struct Regs Regs;
extern unsigned char Mem[];

extern int Step();
extern unsigned char DisAsm(unsigned char *buf, unsigned short offset);
